<?php

namespace Teknisa\CADFIN\Services;

use Teknisa\CADFIN\Factories\Pag41100ContaPagarFactory;

class Pag41100ContaPagarService {
  
  protected $pag41100ContaPagarFactory; 
  
  public function __construct(Pag41100ContaPagarFactory $pag41100ContaPagarFactory) {
    $this->pag41100ContaPagarFactory = $pag41100ContaPagarFactory;
  }
  
  public function getNvMaxContctbl() {
    
    return $this->pag41100ContaPagarFactory->findNvMaxContctbl();
    
  }
  
  public function saveEmpresa($row) {
    try{
      $arrayCdempresa = $row['CDEMPRESA'];
      $nrorg = $row['NRORG'];
      $operador = $row['CDOPERADOR']; 
      $i = 0;
      foreach ($arrayCdempresa as $cdempresa){
          $selectEmpresa = $this->pag41100ContaPagarFactory->selectEmpresa($cdempresa, $row['CDTPCTPAGAR']);
          if(empty($selectEmpresa)){
            $params = array(
              "CDEMPRESA"       => $cdempresa,
              "CDOPERINCLUSAO"  => $operador,
              "CDOPERULTATU"    => $operador,
              "CDTPCTPAGAR"     => $row['CDTPCTPAGAR'],
              "DTINCLUSAO"      => $row['DATA'],
              "DTULTATU"        => $row['DATA'],
              "IDATIVO"         => 'S',
              "NRORG"           => $nrorg,
              "NRORGINCLUSAO"   => $nrorg,
              "NRORGULTATU"     => $nrorg
            );
            $i++;
            
            $this->pag41100ContaPagarFactory->saveEmpresa($params);
          }
      }
      
    } catch(\Exception $e) {
        throw $e;
    }
    
  }
  
  public function cadastroAutomaticoEmpresa($row) {
    try{
      
      $arrayTipoContPag = $row["CDTPCTPAGAR"];
      
      foreach($arrayTipoContPag as $tipoContPag){
          $rowToSave = $row;
          $rowToSave['CDTPCTPAGAR'] = $tipoContPag;
          if($row['IDOPERACAO'] === 'I'){
            $this->saveEmpresa($row);
          } 
          else if($row['IDOPERACAO'] === 'S'){
            $this->pag41100ContaPagarFactory->deleteEmpresa($rowToSave['CDTPCTPAGAR']);
            
            $this->saveEmpresa($row);
          }
          
      }
      
    } catch(\Exception $e) {
        throw $e;
    }
    
  }
  
}
